Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Types | Protected Attributes
Lucene::BitSet Class Reference

`#include <BitSet.h>`

Inheritance diagram for Lucene::BitSet:

## Public Member Functions

| BitSet (uint32_t size=0)
virtual | ~BitSet ()
virtual String | getClassName ()
boost::shared_ptr< BitSet > | shared_from_this ()
get_bits_result | getBits ()
void | clear ()
void | clear (uint32_t bitIndex)
void | fastClear (uint32_t bitIndex)
void | clear (uint32_t fromIndex, uint32_t toIndex)
void | fastClear (uint32_t fromIndex, uint32_t toIndex)
void | set (uint32_t bitIndex)
void | fastSet (uint32_t bitIndex)
void | set (uint32_t bitIndex, bool value)
void | fastSet (uint32_t bitIndex, bool value)
void | set (uint32_t fromIndex, uint32_t toIndex)
void | fastSet (uint32_t fromIndex, uint32_t toIndex)
void | set (uint32_t fromIndex, uint32_t toIndex, bool value)
void | fastSet (uint32_t fromIndex, uint32_t toIndex, bool value)
void | flip (uint32_t bitIndex)
void | fastFlip (uint32_t bitIndex)
void | flip (uint32_t fromIndex, uint32_t toIndex)
void | fastFlip (uint32_t fromIndex, uint32_t toIndex)
uint32_t | size () const
uint32_t | numBlocks () const
bool | isEmpty () const
bool | get (uint32_t bitIndex) const
bool | fastGet (uint32_t bitIndex) const
int32_t | nextSetBit (uint32_t fromIndex) const
void | _and (const BitSetPtr &set)
void | _or (const BitSetPtr &set)
void | _xor (const BitSetPtr &set)
void | andNot (const BitSetPtr &set)
bool | intersectsBitSet (const BitSetPtr &set) const
uint32_t | cardinality ()
void | resize (uint32_t size)
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()

## Protected Types

typedef boost::dynamic_bitset< uint64_t > | bitset_type
typedef const uint64_t * | get_bits_result

## Protected Attributes

bitset_type | bitSet
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Member Typedef Documentation

## ◆ bitset_type

typedef boost::dynamic_bitset<uint64_t> Lucene::BitSet::bitset_type

protected

## ◆ get_bits_result

typedef const uint64_t* Lucene::BitSet::get_bits_result

protected

## Constructor & Destructor Documentation

## ◆ BitSet()

Lucene::BitSet::BitSet | ( | uint32_t | size = 0 | ) |

References size().

Referenced by _getClassName().

## ◆ ~BitSet()

virtual Lucene::BitSet::~BitSet | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _and()

void Lucene::BitSet::_and | ( | const BitSetPtr & | set | ) |

References set().

## ◆ _getClassName()

String Lucene::BitSet::_getClassName | ( |  | ) |

inline static

References BitSet().

## ◆ _or()

void Lucene::BitSet::_or | ( | const BitSetPtr & | set | ) |

References set().

## ◆ _xor()

void Lucene::BitSet::_xor | ( | const BitSetPtr & | set | ) |

References set().

## ◆ andNot()

void Lucene::BitSet::andNot | ( | const BitSetPtr & | set | ) |

References set().

## ◆ cardinality()

uint32_t Lucene::BitSet::cardinality | ( |  | ) |

## ◆ clear() [1/3]

void Lucene::BitSet::clear | ( |  | ) |

## ◆ clear() [2/3]

void Lucene::BitSet::clear | ( | uint32_t | bitIndex | ) |

## ◆ clear() [3/3]

void Lucene::BitSet::clear | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex )

## ◆ clone()

virtual LuceneObjectPtr Lucene::BitSet::clone | ( | const LuceneObjectPtr & | other = LuceneObjectPtr() | ) |

virtual

Return clone of this object.

Parameters

  other | clone reference - null when called initially, then set in top virtual override.

Reimplemented from Lucene::LuceneObject.

## ◆ equals()

virtual bool Lucene::BitSet::equals | ( | const LuceneObjectPtr & | other | ) |

virtual

Return whether two objects are equal.

Reimplemented from Lucene::LuceneObject.

## ◆ fastClear() [1/2]

void Lucene::BitSet::fastClear | ( | uint32_t | bitIndex | ) |

## ◆ fastClear() [2/2]

void Lucene::BitSet::fastClear | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex )

## ◆ fastFlip() [1/2]

void Lucene::BitSet::fastFlip | ( | uint32_t | bitIndex | ) |

## ◆ fastFlip() [2/2]

void Lucene::BitSet::fastFlip | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex )

## ◆ fastGet()

bool Lucene::BitSet::fastGet | ( | uint32_t | bitIndex | ) | const

## ◆ fastSet() [1/4]

void Lucene::BitSet::fastSet | ( | uint32_t | bitIndex | ) |

## ◆ fastSet() [2/4]

void Lucene::BitSet::fastSet | ( | uint32_t | bitIndex,
|  | bool | value )

## ◆ fastSet() [3/4]

void Lucene::BitSet::fastSet | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex )

## ◆ fastSet() [4/4]

void Lucene::BitSet::fastSet | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex,
|  | bool | value )

## ◆ flip() [1/2]

void Lucene::BitSet::flip | ( | uint32_t | bitIndex | ) |

## ◆ flip() [2/2]

void Lucene::BitSet::flip | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex )

## ◆ get()

bool Lucene::BitSet::get | ( | uint32_t | bitIndex | ) | const

## ◆ getBits()

get_bits_result Lucene::BitSet::getBits | ( |  | ) |

## ◆ getClassName()

virtual String Lucene::BitSet::getClassName | ( |  | ) |

inline virtual

## ◆ hashCode()

virtual int32_t Lucene::BitSet::hashCode | ( |  | ) |

virtual

Return hash code for this object.

Reimplemented from Lucene::LuceneObject.

## ◆ intersectsBitSet()

bool Lucene::BitSet::intersectsBitSet | ( | const BitSetPtr & | set | ) | const

References set().

## ◆ isEmpty()

bool Lucene::BitSet::isEmpty | ( |  | ) | const

## ◆ nextSetBit()

int32_t Lucene::BitSet::nextSetBit | ( | uint32_t | fromIndex | ) | const

## ◆ numBlocks()

uint32_t Lucene::BitSet::numBlocks | ( |  | ) | const

## ◆ resize()

void Lucene::BitSet::resize | ( | uint32_t | size | ) |

References size().

## ◆ set() [1/4]

void Lucene::BitSet::set | ( | uint32_t | bitIndex | ) |

Referenced by _and(), _or(), _xor(), andNot(), and intersectsBitSet().

## ◆ set() [2/4]

void Lucene::BitSet::set | ( | uint32_t | bitIndex,
|  | bool | value )

## ◆ set() [3/4]

void Lucene::BitSet::set | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex )

## ◆ set() [4/4]

void Lucene::BitSet::set | ( | uint32_t | fromIndex,
|  | uint32_t | toIndex,
|  | bool | value )

## ◆ shared_from_this()

boost::shared_ptr< BitSet > Lucene::BitSet::shared_from_this | ( |  | ) |

inline

## ◆ size()

uint32_t Lucene::BitSet::size | ( |  | ) | const

Referenced by BitSet(), and resize().

## Field Documentation

## ◆ bitSet

bitset_type Lucene::BitSet::bitSet

protected

The documentation for this class was generated from the following file:

- BitSet.h

clucene.sourceforge.net